\name{Rfast-package}
\alias{Rfast-package}
\docType{package}
\title{
Really fast R functions
}

\description{
A collection of Rfast functions for data analysis. 
Note 1: The vast majority of the functions accept matrices only, not data.frames. 
Note 2: Do not have matrices or vectors with have missing data (i.e NAs). We do no check about them and C++ internally transforms them into zeros (0), so you may get wrong results.
Note 3: In general, make sure you give the correct input, in order to get the correct output. We do no checks and this is one of the many reasons we are fast.   
}

\details{
\tabular{ll}{
Package: \tab Rfast\cr
Type: \tab Package\cr
Version: \tab 1.8.2 \cr
Date: \tab 2017-07-21\cr
License: \tab GPL-2\cr
}
}

\author{
Manos Papadakis <papadakm95@gmail.com>, Michail Tsagris <mtsagris@yahoo.gr>, Marios Dimitriadis <kmdimitriadis@gmail.com>, Ioannis Tsamardinos <tsamard@csd.uoc.gr> , Matteo Fasiolo <matteo.fasiolo@gmail.com>, Giorgos Borboudakis 
<borbudak@gmail.com> and John Burkardt <jburkardt@fsu.edu>
}

\section{Maintainers }{
Manos Papadakis <papadakm95@gmail.com>
}

\note{
Acknowledgments:

We would like to acknowledge Professor Kurt Hornik, Doctor Uwe Ligges (and the rest of R core team) for their 
invaluable help with this R package. Erich Studerus for his invaluable comments and Neal Fultz for his suggestions. 
Vassilis Vasdekis for his invaluable help with the random effects models. Marios Dimitriadis work was funded by the 
Special Account for Research Funds of the University of Crete, Department of Computer Science. Phillip Sai is 
greatly acknowledged for his help with the Floyd-Warshal algorithm. 
}

\keyword{ G^2 test }
\keyword{ variances }
\keyword{ t-tests }
\keyword{ univariate regressions }
\keyword{ Mahalanobis distance }